//+------------------------------------------------------------------+
//|                                             ReturnsIndicator.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "denkir"
#property link      "denkir@gmail.com"
#property version   "1.00"
#property description "    "
#property description "  r_t= ln(P_t/P_(t-1) )"


#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
//---- plot Returns
#property indicator_label1  "Returns"
#property indicator_type1   DRAW_LINE
#property indicator_color1  Blue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

//--- indicator buffers
double         ReturnsBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,ReturnsBuffer,INDICATOR_DATA);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,      //   price[]
                const int prev_calculated,  //      
                const int begin,            //      price[]   
                const double& price[])      // ,      
  {
//---
   int start;
   if(prev_calculated<2) start=1;  //   ReturnsBuffer[]   1-  
   else start=prev_calculated-1;   //  start     
   for(int i=start;i<rates_total;i++)
      ReturnsBuffer[i]=MathLog(price[i]/price[i-1]);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
